// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from kuka_driver_interfaces:msg/FRIState.idl
// generated code does not contain a copyright notice

#ifndef KUKA_DRIVER_INTERFACES__MSG__DETAIL__FRI_STATE__STRUCT_H_
#define KUKA_DRIVER_INTERFACES__MSG__DETAIL__FRI_STATE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Struct defined in msg/FRIState in the package kuka_driver_interfaces.
/**
  * Message describing the state of the robot and FRI
 */
typedef struct kuka_driver_interfaces__msg__FRIState
{
  /// FRI session state enum
  /// IDLE = 0, MONITORING_WAIT = 1, MONITORING_READY = 2,COMMANDING_WAIT = 3, COMMANDING_ACTIVE = 4
  int32_t session_state;
  /// FRI connection quality
  /// POOR = 0, FAIR = 1, GOOD = 2, EXCELLENT = 3
  int32_t connection_quality;
  /// Safety state
  /// NORMAL_OPERATION = 0, SAFETY_STOP_LEVEL_0 = 1, SAFETY_STOP_LEVEL_1 = 2, SAFETY_STOP_LEVEL_2 = 3
  int32_t safety_state;
  /// Client command mode
  /// NO_COMMAND_MODE = 0, POSITION = 1, WRENCH = 2, TORQUE = 3
  int32_t command_mode;
  /// Control mode of the robot
  /// POSITION_CONTROL_MODE = 0, CART_IMP_CONTROL_MODE = 1, JOINT_IMP_CONTROL_MODE = 2, NO_CONTROL = 3
  int32_t control_mode;
  /// Operation mode
  /// TEST_MODE_1 = 0, TEST_MODE_2 = 1, AUTOMATIC_MODE = 2
  int32_t operation_mode;
  /// Drive state
  /// OFF = 0, TRANSITIONING = 1, ACTIVE = 2
  int32_t drive_state;
  /// Overlay overlay_type
  /// NO_OVERLAY = 0, JOINT = 1, CARTESIAN = 2
  int32_t overlay_type;
  /// Tracking performance of the robot
  /// Indicates how well the commanded robot is able to follow the commands of the FRI client.
  /// The best possible value is 1.0, when the robot executes the given commands instantaneously.
  /// The tracking performance is always 0 when the session state is not COMMANDING_ACTIVE.
  double tracking_performance;
} kuka_driver_interfaces__msg__FRIState;

// Struct for a sequence of kuka_driver_interfaces__msg__FRIState.
typedef struct kuka_driver_interfaces__msg__FRIState__Sequence
{
  kuka_driver_interfaces__msg__FRIState * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} kuka_driver_interfaces__msg__FRIState__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // KUKA_DRIVER_INTERFACES__MSG__DETAIL__FRI_STATE__STRUCT_H_
